package	jp.co.sds_corp.ratemixer.fx.command;

import java.rmi.Naming;
import java.util.Map;

import jp.co.sds_corp.fxutil.Ccy;
import jp.co.sds_corp.fxutil.CcyPair;
import jp.co.sds_corp.ratemixer.fx.FxRate;
import jp.co.sds_corp.util.config.IConfiguration;

public class RMICommander implements ICommander
{
	String	host;
	int		port;
	String	name;
	String	url;
	IRMIServer	remote;

	/**
	* 指定された初期情報でDummySourceを初期化します。
	* @param    config  初期情報
	*/
	public void init( IConfiguration config ) throws Exception {
		host = config.get( "host" );
		port = Integer.valueOf( config.get( "port" ) ).intValue();
		name = config.get( "name" );

		url = "rmi://" + host + ":" + port + "/" + name;
		remote = (IRMIServer )Naming.lookup( url );
	}

	public Map<String,Ccy> mapCcy() throws Exception {
		return remote.mapCcy();
	}

	public Map<String,CcyPair> mapCcyPair() throws Exception {
		return remote.mapCcyPair();
	}

	public FxRate getSpotRate( String ccy1, String ccy2 )
		throws Exception
	{
		return remote.getSpotRate( ccy1, ccy2 );
	}

	public CcyPairProperty getCcyPairProperty( String ccy1, String ccy2 )
		throws Exception
	{
		return remote.getCcyPairProperty( ccy1, ccy2 );
	}

	public void setCcyPairProperty( String ccy1, String ccy2,
			CcyPairProperty prop )
		throws Exception
	{
		remote.setCcyPairProperty( ccy1, ccy2, prop );
	}

	public void setStatus( String ccy1, String ccy2, int status )
		throws Exception
	{
		remote.setStatus( ccy1, ccy2, status );
	}

}
